<?php
namespace FM\Service;

use FM\Factory\GLocaisFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;

class GLocaisService {
    
    protected $GLocaisFactory;
    protected $Environment;
    protected $newCode;
    
    public function __construct (GLocaisFactory $GLocaisFactory, Environment $Environment, NewCode $newCode) {
        $this->GLocaisFactory  = $GLocaisFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
    }

    public function getServiceUnities($params){
        
        $validParam = '';
        
        if($params['inputLocalAt'] != '' && $params['inputLocalAt'] != null ) {
            $validParam = " AND UPPER(FCM_LOCALCLI.NMLOCALCLIENTE) LIKE UPPER('%".$params['inputLocalAt']."%')";
        }
 
        $operadores = $this->GLocaisFactory->getFactoryUnities($validParam);
        return $operadores;
    }
    
    public function getServiceLocal($nrlocalclientepai){
        $locationsList = array(); // onde vai ser salvo todos os locais 
       
        $params = array(
            'NRLOCALCLIENTEPAI' => $nrlocalclientepai  
        );
        $operadores = $this->GLocaisFactory->getFactoryLocal($params); // locais filhos do agrupamento completo
        return $operadores;
    }

    public function getServiceLocalType($params){
        
        $validParam = '';
        
        if($params['inputLocal'] != '' && $params['inputLocal'] != null ) {
            $validParam = " WHERE UPPER(FCM_TIPOLOCALCLI.NMTIPOLOCALCLI) LIKE UPPER('%".$params['inputLocal']."%') ";
        }
        $operadores = $this->GLocaisFactory->getFactoryLocalType($validParam);
        return $operadores;
    }
    
    // Deleta um local e seus filhos
    public function deleteLocation($params){
        $cont = 0;
        $locationsList = $params['locationsList'];
        $locationsIdsString = implode(",", $locationsList);
        
       foreach($locationsList as $locationId){
            $countLocations = $this->GLocaisFactory->validLocationTask($locationId); // Valida se o local está sendo usado para alguma tarefa
            $validation = $countLocations[0]['VALIDA'];
           
            if($validation == 0){
                $countLocations = $this->GLocaisFactory->validLocationInspection($locationId);
                $validation = $countLocations[0]['VALIDA'];
                
                if($validation != 0) {
                    $cont = $cont + 1;
                }
            } else {
                $cont = $cont + 1;
            }
        }
        
        if($cont == 0 ) {
            try {
                $this->GLocaisFactory->deleteLocation($locationsIdsString);
                $response = 'Deletado com sucesso';
            } catch(\Exception $e) {
                $response = $e->getMessage();
            }
        } else {
            $response = 'Erro. Local está sendo usado.';
        }

        return $response;
    }
}
?>