/*
Nome: 2812_EXPTRGS_GRAVA_CANCELAMENTO_EXP.SQL

Descrio:
   Trigger para gravar as notas fiscais deletadas pelo expedio

Criao:
   28/01/2011 - Wander Dutra de Morais Neto

Descrio: A trigger insere registros na tabela HISTLOGCANCNOTA a partir da excluso de registros da tabela
              ITEMPRODUTO */
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE o.name = 'GRAVA_CANCELAMENTO_EXP'  and
                type = 'TR'                 and
                u.uid = o.uid               and
                u.name = USER)

DROP TRIGGER GRAVA_CANCELAMENTO_EXP
GO

CREATE TRIGGER GRAVA_CANCELAMENTO_EXP
ON ITEMPRODUTO
FOR DELETE

AS

DECLARE @V_OLD_CDFILIALNFCANC VARCHAR(4);
DECLARE @V_OLD_NRLANCNFCANC VARCHAR(10);
DECLARE @V_OLD_NRSEQITPROD VARCHAR(4);                                                                                                                                                                                 
DECLARE @V_DTHRCANCNF DATETIME;                                                                                                                                                                                          
DECLARE @V_CDOPERCANCNF VARCHAR(12);                                                                                                                                                                                  
DECLARE @V_CDCLIFILCANC VARCHAR(21);                                                                                                                                                                                  
DECLARE @V_NREXPCANC VARCHAR(10);
DECLARE @V_DTLANCNFCANC DATETIME;
DECLARE @V_OLD_NRPEDIDO varchar(10);
DECLARE @V_OLD_NRITEMPED varchar(10);
DECLARE @V_IDORIGDESNFCAN VARCHAR(1);
DECLARE @V_OLD_CDPRODCANC VARCHAR(10);
DECLARE @V_IDENTRSAIDOP VARCHAR(1);
DECLARE @V_IDSISTEMA VARCHAR(3);

BEGIN
     DECLARE C_CURSOR CURSOR FOR
      SELECT CDFILIAL, NRLANCTONF, NRSEQITPROD, NRPEDIDO, NRITEMPED, CDPRODUTO
       FROM DELETED;
     OPEN C_CURSOR;

     FETCH NEXT FROM C_CURSOR INTO @V_OLD_CDFILIALNFCANC, @V_OLD_NRLANCNFCANC, @V_OLD_NRSEQITPROD, @V_OLD_NRPEDIDO, @V_OLD_NRITEMPED, @V_OLD_CDPRODCANC;
    
     WHILE (@@FETCH_STATUS = 0) BEGIN     

      SELECT @V_CDCLIFILCANC = (CASE IDORIGDESTNF WHEN 'C' THEN CDCLIENTE ELSE CDFILIRECE END)
       FROM NOTAFISCAL
      WHERE NOTAFISCAL.CDFILIAL =  @V_OLD_CDFILIALNFCANC
      AND   NOTAFISCAL.NRLANCTONF = @V_OLD_NRLANCNFCANC


     
      SELECT @V_NREXPCANC = NREXPEDICAO, @V_DTLANCNFCANC = DTLANCAMENNF, @V_IDORIGDESNFCAN = IDORIGDESTNF, @V_IDENTRSAIDOP = IDENTRSAIDOP, @V_IDSISTEMA = IDSISTEMA
       FROM NOTAFISCAL
      WHERE NOTAFISCAL.CDFILIAL =  @V_OLD_CDFILIALNFCANC
      AND   NOTAFISCAL.NRLANCTONF = @V_OLD_NRLANCNFCANC



      SELECT @V_CDOPERCANCNF = MAX(CDOPERADOR)
       FROM ITEMPEDIDO
      WHERE ITEMPEDIDO.CDFILIAL = @V_OLD_CDFILIALNFCANC
      AND   ITEMPEDIDO.NRPEDIDO = @V_OLD_NRPEDIDO
      AND   ITEMPEDIDO.NRITEMPED = @V_OLD_NRITEMPED    
      

     IF (@V_IDORIGDESNFCAN = 'C') BEGIN 
           INSERT INTO HISTLOGCANCNOTA
               (CDFILIALNFCANC, NRLANCNFCANC, NRSEQITPROCANC, DTHRCANCNF, CDOPERCANCNF, CDCLINFCANC, NREXPCANC, DTLANCNFCANC, CDFILIRECECANC, IDORIGDESNFCAN, CDPRODCANC)
           VALUES
               (@V_OLD_CDFILIALNFCANC, @V_OLD_NRLANCNFCANC, @V_OLD_NRSEQITPROD, GETDATE(), @V_CDOPERCANCNF, @V_CDCLIFILCANC, @V_NREXPCANC, @V_DTLANCNFCANC, NULL, @V_IDORIGDESNFCAN, @V_OLD_CDPRODCANC);
          END;
      ELSE IF (@V_IDORIGDESNFCAN = 'L') BEGIN
           INSERT INTO HISTLOGCANCNOTA
               (CDFILIALNFCANC, NRLANCNFCANC, NRSEQITPROCANC, DTHRCANCNF, CDOPERCANCNF, CDCLINFCANC, NREXPCANC, DTLANCNFCANC, CDFILIRECECANC, IDORIGDESNFCAN, CDPRODCANC)
           VALUES
               (@V_OLD_CDFILIALNFCANC, @V_OLD_NRLANCNFCANC, @V_OLD_NRSEQITPROD, GETDATE(), @V_CDOPERCANCNF, NULL, @V_NREXPCANC, @V_DTLANCNFCANC, @V_CDCLIFILCANC, @V_IDORIGDESNFCAN, @V_OLD_CDPRODCANC);
     END;    

    FETCH NEXT FROM C_CURSOR INTO @V_OLD_CDFILIALNFCANC, @V_OLD_NRLANCNFCANC, @V_OLD_NRSEQITPROD, @V_OLD_NRPEDIDO, @V_OLD_NRITEMPED,      @V_OLD_CDPRODCANC;
  END;
     CLOSE C_CURSOR;
     DEALLOCATE C_CURSOR;
END; 
GO
-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_CANCELAMENTO_EXP','5.20.001';
GO